	.XLIST
	.z80
;****************************************************************
;*								*
;*  NDR-Computer Z80-CPM3					*
;*  rel	1.0 vom 07.01.85    					*
;*								*
;* Dieses Programmsegment enthaelt alle Vorgabewerte und	*
;* Konstanten, die mehrmals in anderen Programmteilen auf-	*
;* tauchen oder der Steuerung eines Assemblerdurchlaufes	*
;* dienen. Im Normalfalle muss nur dieses Programmsegment	*
;* geaendert werden um 'andere' CP/M+ Systeme zu erstellen	*
;*								*
;* In diesem Programmsegment werden auch alle Aenderungen	*
;* nachgehalten die im Laufe der Zeit an den einzelnen		*
;* Unterprogrammen vorgenommen wurden ... wir empfehlen dem	*
;* Anwender dies beizubehalten					*
;*								*
;* Dieses Programmsegment ist NUR sinnvoll wenn neu assembliert	*
;* werden soll - es dient sonst lediglich der allgemeinen	*
;* Information							*
;*								* 
;* geschrieben von RAOUL O.KOERBER				*
;*								*
;**************************************************************** 	

	; ********************************
	; Fehler und Aenderungsrapport
	; ********************************

rel	equ	'1'		; Haupt'Ausgabe'
rev	equ	'0'		; wichtige Revision
usr	equ	'0'		; Benutzerrevision

;****************************************************************
;*								*
;* am		wo	was					*
;* ------------------------------------------------------------	*
;*							*
;****************************************************************

	; ********************************
	; Vorgabewerte
	; ******************************** 

	; ****************
	; Assembler
	; ****************

ja	equ	-1		; Bedingungsflags
nein	equ	not ja
banked	equ	ja

	; ****************
	; ASCII
	; ****************

null	equ	0
ctlq	equ	'Q'-'@'
ctls	equ	'S'-'@'
bell	equ	07h
bs	equ	08h		; Backspace
ht	equ	09h		; Cursor rechts ( Hor-Tab)
lf	equ	0ah		; Zeilenvorschub ( linefeed)
vt	equ	0bh		; Cursor 'rauf ( Ver-Tab)
ff	equ	0ch		; Cursor rechts
cr	equ	0dh		; Return
syn	equ	16h		; Cursor eine Zeile 'runter
cls	equ	1ah		; CLS Bildschrim loeschen
esc	equ	1bh		; ESC-Zeichen
fs	equ	1ch		; CUROFF
gs	equ	1dh		; CURON
chome	equ	1eh		; Cursor HOME
newline	equ	1fh		; CRLF
blank	equ	20h

	; ****************
	; Systemadressen
	; ****************

tpa	equ	00100h		; Start des TPA-Bereiches
ccp	equ	tpa		; Einsprung in CCP
bbram	equ	04000h		; Start RAM in BOOT-Karte
monseg	equ	0f400h		; Start des Monitorsegmentes
ioseg	equ	0fc00h		; IO-Segment USER-AREA

	; nachfolgende UP's rufen Programmsegmente in MONIO 
	; (den IO-Segment von ELMON ) auf - welche ihrerseits
	; auf das BOOT-ROM-Segment in FLOMON zurueckgreifen.
	; Diese (etwas umstaendliche) Prozedur ist fuer CP/M3
	; notwendig, da hier der IO-Einsprung aus verschiedenen
	; Banken erfolgen kann - FLOMON dies aber nicht unterstuetzt
	; gleichzeitig wurde der Vorteil einer 3k groesseren TPA
	; erreicht

econist equ	0fc00h		; Konsolenstatus (EIN) aus MONIO
econin	equ	0fc03h		; Konsoleneingabe aus MONIO
econout equ	0fc06h		; Standart-Ausgabe
esetbnk	equ	0fc24h		; Bankumschaltung (mit ROM-Ausschaltung)
efloppy	equ	0fc27h		; Floppy-Treiber
ecurbnk	equ	0fc34h		; Bankadresse (gueltige)	
e@dbnk	equ	0fc35h		; @DBNK in MONIO
e@cbnk	equ	0fc36h		; @CBNK in MONIO

	; ****************
	; PORTS
	; ****************

	; **** Centronic

ioec	equ	40h		; Basisport
iodat	equ	ioec+8
iocmd	equ	ioec+9

	; **** SER mit UART 6551 als Terminal 
	
ubas	equ	0fch		; Basisport
udat	equ	ubas		; Datenport
usta	equ	udat+1
ucmd	equ	udat+2
ucon	equ	udat+3
	
	; **** SER mit UART 6551 als SERieller Drucker	
	
ubas1	equ	0ech		; Basisport
udat1	equ	ubas1
usta1	equ	udat1+1
ucmd1	equ	udat1+2
ucon1	equ	udat1+3
	
	; **** SER mit UART 6551 als AUX
	
ubas2	equ	0cch		; Basisport
udat2	equ	ubas2
usta2	equ	ubas2+1
ucmd2	equ	ubas2+2
ucon2	equ	ubas2+3
	
	; **** Serielle Schnittstelle KAS
	
casbas	equ	0cah
cmdcas	equ	casbas
datcas	equ	casbas+1
	
	; **** Tastatur
	
keybas	equ	068h
keyd	equ	keybas
keys	equ	keybas+1

	; **** Bootkarte

	; Ausgabe schaltet mit BIT7 gesetzt RAM/(EP)ROM aus
	; mit BIT7 =0 RAM/(EP)ROM aus
	; Bit 0..3 kann mit Ausgabe als BANK-Adresse (16..19) gesetzt werden
	; Bit 4..6 sind derzeit unbelegt

bbport	equ	0c8h

	; ****  FLO2

	; Belegung der Ports FDCSEL und FDCIRG
	;
	; bit: 	7	6	5	4	3	2	1	0
	;fdcirq	drq	irq	hld	2sided	-	-	-	-
	;fdcset	side	moton	mini	dd	ds4	ds3	ds2	ds1

fcbas	equ	0c0h
fdccmd	equ	fcbas		; Status und Befehlsregister
fdctrk	equ	fcbas+1		; Trackregister
fdcsec	equ	fcbas+2		; Sektorregister
fdcdat	equ	fcbas+3		; Datenregister
fdcsel	equ	fcbas+4		; Selektport
fdcirq	equ	fcbas+4		

	; FDC - Befehle (

seek	equ	00010001b	; mit HLD ohne VERIFY
home	equ	00000001b	; mit HLD ohne VERIFY
reads	equ	10001000b	; phys Sektor lesen IBM Format
writes	equ	10101000b	; phys Sektor schreiben IBM FORMAT
readid	equ	11000100b	; ID-Feld lesen
readt	equ	11100100b	; Track ( kompl ) lesen
writet	equ	11110100b	; Track ( kompl ) schreiben
forcei	equ	11010000b	; Alle laufenden Funktionen abbrechen

	; Bei Selekt side2-moton-minis-sdens dazufuegen soweit noetig

sela	equ	00000001b	; Laufwerk A
selb	equ	00000010b	; Laufwerk B
selc	equ	00000100b	; Laufwerk C
seld	equ	00001000b	; Laufwerk D

side2	equ	10000000b	; Seite 2 ( Achtung JUMPER )
minis	equ	00100000b	; BIT5=1 mini-Laufwerke
sdens	equ	00010000b	; BIT4=1 sdens BIT4=0 ddens

	; ****************
	; XMOVE Puffer
	; ****************

	; je 'groesser' dieser Puffer ist um so schneller wird
	; zwischen den Banken hin und her 'geschaufelt'
	; 3 Dinge sind jedoch zu beachten:
	; Die Puffergroesse geht voll von der TPA-Groesse ab !
	; Der Puffer muss im gemeinsamen RAM-Bereich liegen
	; Eine Puffergroesse unter 100H Bytes bringt kleinen 
	; Gewinn ... das kann MOVE vom BDOS gesteuert auch ...
	;
a$bbuf	equ	0fa00h		; Pufferstart
a$bend	equ	0fc00h		; Pufferende+1
a$blen	equ	a$bend-a$bbuf	; Pufferlaenge

	; ****************
	; CCP - Bank
	; ****************

	; fuer einen schnelleren WARMBOOT, wird CCP.COM beim Kaltstart
	; auf Bank 0 transferiert. Von dort wird es nach jedem Warmstart
	; geholt anstelle es jedesmal von der Diskette zu lesen ...

ccpbnk	equ	0		; in Bank 0
ccpis	equ	0C000h		; dort wird CCP 'zwischengelagert'
ccplen	equ	0d00h		; so 'lang' ist CCP

	; ****************
	; Laufwerke
	; ****************

	; hier UNVERAENDERBARE Rechenwerte (Laufwerksbezeichnung)

	; einfache Dichte

maxi	equ	1		; 8-zoll

	; 

t40d	equ	3		; 40 Track 2-seitig 
t80d	equ	5		; 80 Track 2-seitig

ram	equ	6		; vorgesehen als RAM-Disk
hard	equ	7		; vorgesehen als Harddisk

	; hier gewuenschter Laufwerkstyp (MAXI-T80D-T40S usw)
	; unter gewuenschtem Laufwerk eintragen
	; Nicht belegte Laufwerke muessen mit NEIN eingetragen werden

adrive	equ	t80d		; Laufwerk A
bdrive	equ	t40d		; Laufwerk B
cdrive	equ	t80d		; Laufwerk C
ddrive	equ	t80d		; Laufwerk D

	; Laufwerk E ist NUR als RAM-DISK (RAM) vorgesehen

edrive	equ	nein		; Laufwerk E

	; Laufwerk F ist NUR als HARD-DISK (HARD) vorgesehen

fdrive	equ	nein		; Laufwerk F

	.LIST

